// testet pricate copyprovate firstprivate lastprivate

#include "stdafx.h"
#include <omp.h>



int _tmain(int argc, _TCHAR* argv[])
{
	int i,j, k;
	omp_set_num_threads(4);
	printf("Max Threads: {0}  Anz CPU {1}", omp_get_max_threads(), omp_get_num_procs() );

	i=1;
	j=2;
	k=3;

	// private:			Wert in der Schleife unbestimmt,                       Absurz
	// firstprivate:	Wert in der Schleife aus der globalen Variablen
	
	#pragma omp parallel private(i)  firstprivate(j) 
	{
		int id = omp_get_thread_num();
		printf("Thread %d  lokales i: %d  lokales j: %d\n", id, i, j );
		i+=id;
		j+=id;	
	}

	printf("Nach Loop i: %d  j: %d\n", i, j);
	printf("\n\n");


	// lastprivate:		der letzte Wert in der Schleife wird der globalen Variablen zugewiesen
	i=-1;
	j=-2;
	int n=10;
	// lastprivate(i)

	//#pragma omp parallel for shared(j) llastprivate(i)
	#pragma omp parallel for shared(j) lastprivate(i)
		for (i=0; i<n-1; i++) {
			j=i;
		}
	printf("Nach Loop i: %d  j: %d\n", i, j);
	printf("\n\n");




	// copyprivate:		der zugewiesene Wert wird allen zugestellt BCast
	float a, b, x, y;
	a=-1;
	b=-2;
	x=-3;
	y=-4;
	#pragma omp parallel private(a,b,x,y)
	{
		#pragma omp single copyprivate(a,b) 
		{
			// lesen aus Datei etc.
			a=2;
			b=3;
			int id = omp_get_thread_num();
			printf("Init durch Thread  %d\n", id);
		}
		int id = omp_get_thread_num();
		x=(float)id;
		y=a+ b*x;
		printf("Thread %d  a: %d  b: %d x: %d  y: %d\n", id, a, b , x, y  );

	}

	char ch[200];
	gets(ch);
	
	return 0;
}




